import { ActionType, SemanticsType, } from "@sfroment/object";
export class ExampleDRPObject {
    semanticsType = SemanticsType.pair;
    _inserts = [];
    _peerId;
    constructor(peerId) {
        this._inserts = [];
        this._peerId = peerId;
    }
    insert(peerId, index, content) {
        if (content.length === 0)
            return;
        this._inserts.splice(index, 0, {
            peerId,
            content,
            color: "red",
        });
    }
    delete(index, length) {
        this._inserts.splice(index, length);
    }
    // insert -> first
    // insert -> delete
    // insert -> insert
    // insert the insert hisght peerID 1st
    // delete the delete highest peerID 1st
    resolveConflicts(vertices) {
        const opInsert = "insert";
        //const opDelete = "delete";
        if (vertices.length <= 1 || vertices[0].hash === vertices[1].hash) {
            return { action: ActionType.Nop };
        }
        const leftOp = vertices[0].operation?.opType;
        const rightOp = vertices[1].operation?.opType;
        const leftPeerId = vertices[0].peerId;
        const rightPeerId = vertices[1].peerId;
        const leftContent = vertices[0].operation?.value[2];
        const rightContent = vertices[1].operation?.value[2];
        if (leftOp === rightOp) {
            if (leftPeerId > rightPeerId) {
                return { action: ActionType.Swap };
            }
            if (leftPeerId === rightPeerId && leftContent > rightContent) {
                return { action: ActionType.Swap };
            }
        }
        if (leftOp !== rightOp) {
            if (rightOp === opInsert) {
                return { action: ActionType.Swap };
            }
        }
        return { action: ActionType.Nop };
    }
    query_insert() {
        return this._inserts;
    }
    query_text() {
        return this._inserts.map((insert) => insert.content).join("");
    }
}
function whoIsWho(peerId) {
    if (peerId === "12D3KooWHJZQSpNVSHXuMvEt76j3zmtXVfDexYmhNm5fWSo99fxQ") {
        return "peer2";
    }
    return "peer1";
}
